<?php

namespace app\controller;

use Illuminate\Database\Eloquent\Builder as EloquentBuilder;
use Illuminate\Database\Query\Builder as QueryBuilder;
use support\exception\BusinessException;
use support\think\Model;
use support\Request;
use support\Response;
use support\think\Db;

class Crud extends Base
{

    /**
     * @var Model
     */
    protected $model = null;

    /**
     * 查询
     * @param Request $request
     * @return Response
     * @throws BusinessException
     */
    public function select(Request $request): Response
    {
        [$where, $format, $limit, $field, $order] = $this->selectInput($request);
        $query = $this->doSelect($where, $field, $order);
        return $this->doFormat($query, $format, $limit);
    }

    /**
     * 添加
     * @param Request $request
     * @return Response
     * @throws BusinessException
     */
    public function insert(Request $request): Response
    {
        $data = $this->insertInput($request);
        $id = $this->doInsert($data);
        return $this->success(__('successful'), ['id' => $id]);
    }

    /**
     * 更新
     * @param Request $request
     * @return Response
     * @throws BusinessException
     */
    public function update(Request $request): Response
    {
        [$id, $data] = $this->updateInput($request);
        $this->doUpdate($id, $data);
        return $this->success(__('successful'));
    }

    /**
     * 删除
     * @param Request $request
     * @return Response
     * @throws BusinessException
     */
    public function delete(Request $request): Response
    {
        $ids = $this->deleteInput($request);
        $this->doDelete($ids);
        return $this->success(__('successful'));
    }

    /**
     * 查询前置
     * @param Request $request
     * @return array
     * @throws BusinessException
     */
    protected function selectInput(Request $request): array
    {
        $field = $request->get('sort');
        $order = $request->get('sortOrder', 'asc');
        $format = $request->get('format', 'normal');
        $limit = (int)$request->get('limit', $format === 'tree' ? 1000 : 10);
        $limit = $limit <= 0 ? 10 : $limit;
        $order = $order === 'asc' ? 'asc' : 'desc';
        $where = $request->get('filter',[]);
        $page = (int)$request->get('page');
        $page = $page > 0 ? $page : 1;
        $allow_column = [];
        //var_dump($this->model->getConnectionName());
        //if ($this->model->getConnection()->getDriverName() == 'mongodb') {
        if ($this->model->getConnection() != 'mysql') {
        } else {
            $table = $this->model->getTable();

            $allow_column = Db::query("desc `$table`");
            if (!$allow_column) {
                throw new BusinessException('表不存在');
            }
            $allow_column = array_column($allow_column, 'Field', 'Field');
            if (!in_array($field, $allow_column)) {
                $field = null;
            }
        }
        return [$where, $format, $limit, $field, $order, $page];
    }

    /**
     * 指定查询where条件,并没有真正的查询数据库操作
     * @param array $where
     * @param string|null $field
     * @param string $order
     * @return Model
     */
    protected function doSelect(array $where, string $field = null, string $order = 'desc')
    {
        $model = $this->model;
        foreach ($where as $column => $value) {
            $symbol = $value['symbol'];
            $value1 = $value['value1'];
            $value2 = $value['value2'];
            if (is_array($value)) {
                if ($symbol === 'like' || $symbol === 'not like') {
                    $model = $model->where($column, $symbol, "%$value1%");
                } elseif (in_array($symbol, ['>', '=', '<', '<>','>=','<='])) {
                    $model = $model->where($column, $symbol, $value1);
                } elseif (($symbol == 'in'|| $symbol == 'not in') && !empty($value1)) {
                    $valArr = $value1;
                    if (is_string($value1)) {
                        $valArr = explode(",", trim($value1));
                    }
                    if($symbol == 'in'){
                        $model = $model->whereIn($column, $valArr);
                    }else{
                        $model = $model->whereNotIn($column, $valArr);
                    }
                } elseif ($symbol == 'null') {
                    $model = $model->whereNull($column);
                } elseif ($symbol == 'not null') {
                    $model = $model->whereNotNull($column);
                } elseif ($symbol == 'range' && $$value1 !== '' || $value2 !== '') {
                    $model = $model->whereBetween($column, [$value1, $value2]);
                }
            } else {
                $model = $model->where($column, $value);
            }
        }
        if ($field) {
            $model = $model->order($field, $order);
        }
        return $model;
    }

    /**
     * 执行真正查询，并返回格式化数据
     * @param $query
     * @param $format
     * @param $limit
     * @return Response
     */
    protected function doFormat($query, $format, $limit,$fields="*"): Response
    {
        $methods = [
            'select' => 'formatSelect',
            'tree' => 'formatTree',
            'table_tree' => 'formatTableTree',
            'normal' => 'formatNormal',
        ];
        if($limit == 'all'){
            $paginator = $query->field($fields)->select();
            $total = count($paginator);
            $items = $paginator;
        }else{
            $paginator = $query->field($fields)->paginate($limit);
            $total = $paginator->total();
            $items = $paginator->items();
        }
        if (method_exists($this, "afterQuery")) {
            $items = call_user_func([$this, "afterQuery"], $items);
        }
        $format_function = $methods[$format] ?? 'formatNormal';
        return call_user_func([$this, $format_function], $items, $total);
    }

    /**
     * 插入前置方法
     * @param Request $request
     * @return array
     * @throws BusinessException
     */
    protected function insertInput(Request $request): array
    {
        $data = $this->inputFilter($request->post());
        $password_filed = 'password';
        if (isset($data[$password_filed])) {
            $data[$password_filed] = password_hash($data[$password_filed],PASSWORD_DEFAULT);
        }
        return $data;
    }

    /**
     * 执行插入
     * @param array $data
     * @return mixed|null
     */
    protected function doInsert(array $data)
    {
        $primary_key = $this->model->getPk();
        $model_class = get_class($this->model);
        $model = $model_class::create($data);
        return $primary_key ? $model->$primary_key : null;
    }

    /**
     * 更新前置方法
     * @param Request $request
     * @return array
     * @throws BusinessException
     */
    protected function updateInput(Request $request): array
    {
        $primary_key = $this->model->getPk();
        $id = $request->post($primary_key);
        $data = $this->inputFilter($request->post());
        $model = $this->model->find($id);
        if (!$model) {
            throw new BusinessException('记录不存在', 2);
        }

        $password_filed = 'password';
        if (isset($data[$password_filed])) {
            // 密码为空，则不更新密码
            if ($data[$password_filed] === '') {
                unset($data[$password_filed]);
            } else {
                $data[$password_filed] = password_hash($data[$password_filed],PASSWORD_DEFAULT);
            }
        }
        unset($data[$primary_key]);
        return [$id, $data];
    }

    /**
     * 执行更新
     * @param $id
     * @param $data
     * @return void
     */
    protected function doUpdate($id, $data)
    {
        $model = $this->model->find($id);
        foreach ($data as $key => $val) {
            $model->{$key} = $val;
        }
        $model->save();
    }

    /**
     * 对用户输入表单过滤
     * @param array $data
     * @return array
     * @throws BusinessException
     */
    protected function inputFilter(array $data): array
    {
        $table = config('database.connections.mysql.prefix') . $this->model->getTable();
        $allow_column = Db::getFields($this->model->getTable());
        if (!$allow_column) {
            throw new BusinessException('表不存在', 2);
        }
        //$columns = array_column($allow_column, 'Type', 'Field');
        //echo json_encode($allow_column);
        foreach ($data as $col => $item) {
            if (!isset($allow_column[$col])) {
                unset($data[$col]);
                continue;
            }
            // 非字符串类型传空则为null
            if ($item === '' && strpos(strtolower($allow_column[$col]['type']), 'varchar') === false && strpos(strtolower($allow_column[$col]['type']), 'text') === false) {
                $data[$col] = null;
            }
            if (is_array($item)) {
                $data[$col] = implode(',', $item);
            }
        }
        if (empty($data['created_at'])) {
            unset($data['created_at']);
        }
        if (empty($data['updated_at'])) {
            unset($data['updated_at']);
        }
        return $data;
    }

    /**
     * 删除前置方法
     * @param Request $request
     * @return array
     * @throws BusinessException
     */
    protected function deleteInput(Request $request): array
    {
        $primary_key = $this->model->getPk();
        if (!$primary_key) {
            throw new BusinessException('该表无主键，不支持删除');
        }
        $ids = $request->post('ids', '');
        if(!is_array($ids)){
            $ids = explode(',',$ids);
        }
        return $ids;
    }

    /**
     * 执行删除
     * @param array $ids
     * @return void
     */
    protected function doDelete(array $ids)
    {
        if (!$ids) {
            return;
        }
        $primary_key = $this->model->getPk();
        $this->model->whereIn($primary_key, $ids)->delete();
    }

    /**
     * 格式化树
     * @param $items
     * @return Response
     */
    protected function formatTree($items): Response
    {
        $format_items = [];
        //$primary_key = $this->model->getPk();
        $primary_key = $this->model->getPk();
        foreach ($items as $item) {
            $item->name = $this->guessName($item) ?: $item->$primary_key;
            $item->value = (string)$item->$primary_key;
            $item->id = $item->$primary_key;
            //$item->pid = $item->pid;
            $format_items[] = $item;
        }
        return $this->success(__('successful'), $format_items);
    }

    /**
     * 格式化表格树
     * @param $items
     * @return Response
     */
    protected function formatTableTree($items): Response
    {
        return $this->success(__('successful'), $items);
    }

    /**
     * 格式化下拉列表
     * @param $items
     * @return Response
     */
    protected function formatSelect($items): Response
    {
        $formatted_items = [];
        $primary_key = $this->model->getPk();
        foreach ($items as $item) {
            $formatted_items[] = [
                'name' => $this->guessName($item) ?: $item->$primary_key,
                'value' => $item->$primary_key
            ];
        }
        return  $this->success(__('successful'), $formatted_items);
    }

    /**
     * 通用格式化
     * @param $items
     * @param $total
     * @return Response
     */
    protected function formatNormal($items, $total): Response
    {
        return json(['code' => 0, 'msg' => 'ok', 'count' => $total, 'data' => $items]);
    }

    /**
     * 查询数据库后置方法，可用于修改数据
     * @param mixed $items 原数据
     * @return mixed 修改后数据
     */
    protected function afterQuery($items)
    {
        return $items;
    }

    /**
     * 猜测记录名称
     * @param $item
     * @return mixed
     */
    protected function guessName($item)
    {
        return $item->title ?? $item->name ?? $item->nickname ?? $item->username ?? $item->id;
    }
    function multi(){
        $ids = Request()->post('ids');
        $params = Request()->post('params');
        parse_str($params,$s);
        $this->model->whereIn('id', [$ids])->update($s);
        return $this->success(__('successful'));
    }
    /**
     * 返回格式化json数据
     *
     * @param int $code
     * @param string $msg
     * @param array $data
     * @return Response
     */
    protected function json(int $code, string $msg = 'ok', array|object $data = []): Response
    {
        return json(['code' => $code, 'data' => $data, 'msg' => $msg]);
    }

    protected function success(string $msg = '成功', array|object $data = []): Response
    {
        return $this->json(0, $msg, $data);
    }

    protected function fail(string $msg = '失败', array|object $data = []): Response
    {
        return $this->json(1,$msg, $data);
    }
    protected function error(string $msg = '失败', array|object $data = []): Response
    {
        return $this->json(1,$msg, $data);
    }
}
